﻿<!DOCTYPE html>
<html lang="zh-cn">
<head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <meta content="width=device-width,minimum-scale=1.0,maximum-scale=1.0,user-scalable=no,minimal-ui" name="viewport">
    <meta name="apple-mobile-web-app-capable" content="yes">
    <meta name="apple-mobile-web-app-status-bar-style" content="black">
    <meta content="telephone=no" name="format-detection">
    <meta name="keywords" content="旅游网,国内旅游,出境旅游,海岛游,遨游网,中青旅遨游网,遨游" />
    <meta name="description" content="遨游网中青旅旗下旅游网站，提供国内游、出境游、海岛游、机票预订服务。电话：400-600-6666" />
    <!-- UC默认竖屏 ，UC强制全屏 -->
    <meta name="full-screen" content="yes">
    <meta name="browsermode" content="application">
    <!-- QQ强制竖屏 QQ强制全屏 -->
    <meta name="x5-orientation" content="portrait">
    <meta name="x5-fullscreen" content="true">
    <meta name="x5-page-mode" content="app">
    <link rel="icon" href="http://pic1.aoyou.com/images/favicon.ico" mce_href="http://pic1.aoyou.com/images/favicon.ico" type="image/x-icon" />
    <link rel="shortcut icon" href="http://pic1.aoyou.com/images/favicon.ico" mce_href="http://pic1.aoyou.com/images/favicon.ico" type="image/x-icon" />
    <link rel="shortcut icon" href="http://pic1.aoyou.com/images/favicon.ico" type="image/x-icon" />
    <title>找不到页面– 遨游网</title>
    <style type="text/css">
        body {
            margin: 0px;
            padding: 0px;
        }

        .wrapBox {
            margin: 0 auto;
            min-width: 320px;
        }

            .wrapBox img {
                width: 100%;
                margin-top: 100px;
            }

        .top {
            height: 45px;
            /*background: #e4f2ff;*/
            position: relative;
            border-bottom: 1px solid;
            border-bottom-color: lightgrey;
        }

            .top .back {
                position: absolute;
                left: 15px;
                top: 10px;
                width: 14px;
                height: 22px;
                background: url(http://pic3.aoyou.com/webapp/common/icon_back.png) 0 0 no-repeat;
                background-size: 100%;
            }

            .top h4 {
                margin: 0px;
                font: 18px sans-serif;
                line-height: 45px;
                text-align: center;
            }

            .top .home {
                position: absolute;
                right: 15px;
                top: 10px;
                width: 25px;
                height: 24px;
                background: url(http://pic3.aoyou.com/webapp/common/icon_index.png) 0 0 no-repeat;
                background-size: 100%;
            }
    </style>
    <script type="text/javascript" src="http://webresource1.aoyou.com/js/webapp/common/zepto.min.js"></script>
</head>
<body>
    <div class="wrapBox">
        <div id="nomarlHead" class="top">
            <em class="back"></em>
            <h4>提示</h4>
            <em class="home"></em>
        </div>
        <header id="microHead" style="background:#e7481f;height:40px;display:none;width:100%;overflow:hidden;background-repeat:no-repeat;text-align:center;line-height:40px;color:#fff;font-size:17px;">
            提示
            <span id="microHome" style="position: absolute; right: 40px; line-height: 40px; font-size: 18px;background: url(http://pic3.aoyou.com/webapp/msite/icon-microshop.png) 0px 0px no-repeat;background-size: 100%;width: 19px;height: 19px;top: 10px;"></span>
            <span id="microMy" style="position: absolute; right: 10px; line-height: 40px; font-size: 18px;background: url(http://pic3.aoyou.com/webapp/msite/icon-microshop.png) 0px -37px no-repeat;background-size: 100%;width: 19px;height: 19px;top: 10px;"></span>
        </header>
        <div></div>
        <img src="http://pic3.aoyou.com/webapp/common/404.png" />
    </div>
</body>
</html>

<script type="text/javascript">

    $(function () {
        var devicetype = getCookie('devicetype');
        $('.top .back').bind('click', function () {
            if (window.action != undefined)
            {
                window.action.pageBack("");
            } else if (window.webkit != undefined) {
                window.webkit.messageHandlers.pageBack.postMessage("");
            }
            else {
                window.history.back()
                window.apit = setTimeout(function () {
                    window.location.replace('http://m.aoyou.com')
                }, 200);
            }
        });

        $('.top .home').bind('click', function () {
            if (devicetype == 'android') {
                //1关闭 2到订单列表
                window.webinfo.closeActivity(1);
            }
            else
                window.location.href = 'http://m.aoyou.com';
        });

        if (getCookie('microshopid') && typeof (getCookie('microshopid')) != 'undefined') {
            $('#nomarlHead').hide();
            $('#microHead').show();
            $('#microHome').click(function () {
                if (getCookie('microshopowner') == '1') {
                    window.top.location.href = 'http://weshop.aoyou.com/Transfer?type=0';
                }
                else {
                    window.top.location.href = 'http://weshop.aoyou.com/Transfer?type=1&shopid=' + getCookie('microshopid');
                }
            });
            if (getCookie('microshopowner') == '1') {
                $('#microMy').hide();
                $('#microHome').css('right', '10px');
            }
            $('#microMy').click(function () {
                window.top.location.href = 'http://mmy.aoyou.com/Home/Index';
            });

        }
        else {
            if (getCookie('isheader') && typeof (getCookie('isheader')) != 'undefined' && getCookie('isheader') == "0") {
                $('#nomarlHead').hide();
                $('#microHead').hide();
            }
            else {
                $('#nomarlHead').show();
                $('#microHead').hide();
            }
        }
    });
    function getCookie(objName) {
        var bikky = document.cookie;
        objName += "=";
        var i = 0;
        while (i < bikky.length) {
            var offset = i + objName.length;
            if (bikky.substring(i, offset) == objName) {
                var endstr = bikky.indexOf(";", offset);
                if (endstr == -1) endstr = bikky.length;
                return decodeURI(bikky.substring(offset, endstr));
            }
            i = bikky.indexOf(" ", i) + 1;
            if (i == 0) break;
        }
        return null;
    }
    window.onpopstate = function (e) {
        clearTimeout(window.apit)
    };
</script>
